#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <math.h>
#include <local.h>
#include <softcris.h>

u_char compressInt(long intensity);

int main(int argc, char *argv[]) {
   struct ce_crisEvt c;
   struct sc_Coords_Traj t;
   struct sc_evt_params p;
   int ret;
   int ntraj = 1;
   long cnt = 0L;
   long firstevtno, lastevtno = 0L;
   int evtnumbers;
   int curday;
   int day1996;
   int endday;
   int startday;
   long *maxI;
   int i;
   long totcnt = 0L;
   long lusec,lnpix;
   long I[6];
   u_char lstim,lR,lnblobs,loffset;
   u_short ltel;

   if(argc != 3) {
      fprintf(stderr, "USAGE: %s startday, endday\n", argv[0]);
      exit(1);
   }
   
   startday = atoi(argv[1]);;
   endday = atoi(argv[2]);
   if(endday < startday ) {
      fprintf(stderr, "%s: endday %d is less than startday %d\n",
      				argv[0],endday,startday);
      exit (1);
   }
   sc_L1_set_day(startday,endday);
   curday = startday;
   /*	1	evtno
   *	2	secs1996
   *	3	evt_offset
   *	4	hazard
   *	5	buffer_id
   *	6	stim
   *	7	ret_code
   *	8	qual
   *	9	next_qual
   *	10	traj_found
   *	11	hop_param
   *	12-17	max_Int
   *	18-23	blob_id
   */
   while((sc_L1_next_cris_evt(&c,&day1996)) != -1) {
      ntraj = 1;
      ret = sc_cris_traj(&c,&t,&ntraj);
      sc_get_evt_params(&p);
      printf("%8ld %2d ",
         c.evtno, c.evt_offset);
      printf("%d %2d %d ",c.hazard,c.buffer_id,c.stim);
      printf("%3d ",p.ret_code);
      if(ret == 0) {
         printf("%3d %3d %2d %6o ",(u_char)(255*t.Q.qual_factor),
	    (u_char)(255*p.nextqual), p.ntraj,t.Q.hop_param);
         for(i=0;i<6;i++) {
	    I[i] = *(sc_layer_maxI()+i);
	    printf("%2d ",compressInt(I[i]));
	 }
	 for(i=0;i<6;i++) {
	    printf("%2d ",t.blobid[i]);
	}
      }
      printf("\n");
      cnt++;
   }
   fprintf(stderr,"day %d: %ld\n",curday,cnt);
   fprintf(stderr,"%s processed %ld evts\n", argv[0], totcnt);

   return 0;
}
u_char compressInt(long intensity) {
    int compressedIntensity =
		((int) ((2.0 * log(intensity+1.0) / log(2.0)) + 0.5)) - 4;
    if (compressedIntensity < 0) return 0x00;
    else return ((u_char) compressedIntensity);
}

